﻿-------------------------------------------------------------------------------
-- Title: Whisper Log
-- Author: Kritologist - Malorne
-------------------------------------------------------------------------------
WhisperLog = LibStub("AceAddon-3.0"):NewAddon("WhisperLog", "AceConsole-3.0")
local L = LibStub("AceLocale-3.0"):NewLocale("WhisperLog", "enUS", true, debug) 

--Saved whispers
WhisperLog_Whispers = {
};
WLwhisperMax = 20


function WhisperLog_OnLoadOptions(self)
	SLASH_WHISPERLOG1 = "/wlog"
   	SlashCmdList["WHISPERLOG"] = WhisperLog_SlashCommand
	self:RegisterEvent("CHAT_MSG_WHISPER")
	self:Hide()
end

	
function WhisperLog_SlashCommand(msg)
	msg = string.lower(msg)
	local args = {}
	
	for word in string.gmatch(msg, "[^%s]+") do
		table.insert(args, word)
	end
		
	
		
	if ( args[1] ) then
		if (args[1] == "clear") then
			WhisperLog_Whispers = {}
			WLUpdateWhispers()
		elseif (args[1] == "setmax") then
			if args[2] then
				WLwhisperMax = tonumber(args[2])
			end
		end
	else
		WhisperLogMainFrame:Show()
		WLUpdateWhispers()
	end
	
	
end

function WhisperLog_OnEvent(self,event, ...)
	if (event == "CHAT_MSG_WHISPER") then
	WhisperLogScroller:Clear()
		table.insert(WhisperLog_Whispers, 1,"|cFFFFFFFF["..arg2.."|cFFFFFFFF]|r"..": "..arg1)
		for i=0, getn(WhisperLog_Whispers) do
			if i > WLwhisperMax then
				WhisperLog_Whispers[i] = nil
			end
		end
		if getn(WhisperLog_Whispers) > WLwhisperMax then
			WhisperLog_Whispers[WLwhisperMax + 1] = nil
		end
		WLUpdateWhispers()
	end
end

function WLUpdateWhispers()
	WhisperLogScroller:Clear()
	local totalWhispers = getn(WhisperLog_Whispers)
	
	for i=0, totalWhispers do
		WLAddMessage(WhisperLog_Whispers[totalWhispers - i])
	end
end
function WLAddMessage(message)
	WhisperLogScroller:AddMessage(message, 1, .5,1,1)
end

function WhisperLogMain_Hide(self)
    WhisperLogMainFrame:Hide()
end

function WhisperLogMain_Show()
	WLUpdateWhispers()
	WhisperLogMainFrame:Show()
end

function WhisperLog:WhisperLogToggleMain()
	if WhisperLogMainFrame:IsVisible() then
		WhisperLogMainFrame:Hide()
	else
		WhisperLogMainFrame:Show()
		WLUpdateWhispers()
	end
end

function WhisperLog_Wheel(self, delta)
	if delta == 1 then
		WhisperLogScroller:ScrollUp()
	else
		WhisperLogScroller:ScrollDown()
	end
end

if not WhisperLog then return end
local L_WhisperLog = LibStub("AceLocale-3.0"):GetLocale("WhisperLog")

LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("WhisperLog", {
	type = "launcher",
	label = "WhisperLog",
	OnClick = function(_, msg)
		if msg == "LeftButton" then
			WhisperLog.WhisperLogToggleMain()
		end
	end,
	icon = "Interface\\AddOns\\WhisperLog\\icon",
	OnTooltipShow = function(tooltip)
		if not tooltip or not tooltip.AddLine then return end
		tooltip:AddLine("WhisperLog")
		tooltip:AddLine("|cffffff00Click|r to toggle whispers")
	end,
})

